--------------------------------------------------------------------------------
-- An example of Quad_MUX_2, quadruple multiplexer of 2 channels with enable
-- This component is like a building block for many other projects 
-- Plan B: algorithmic description of the truth table
---------------------------------------------------
-- Project P2  - CSD 
-- http://digsys.upc.es
--------------------------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;

entity Quad_MUX_2 is
PORT(
	CH0	:IN STD_LOGIC_VECTOR(3 DOWNTO 0); 
	CH1	:IN STD_LOGIC_VECTOR(3 DOWNTO 0); 
	E	:IN STD_LOGIC;
	Y	:OUT STD_LOGIC_VECTOR(3 DOWNTO 0);
	S	:IN STD_LOGIC 
    );
end Quad_MUX_2;

architecture truth_table of Quad_MUX_2 is
begin

Y	<=	CH0  WHEN S ='0' AND E = '1' ELSE
		CH1  WHEN S ='1' AND E = '1' ELSE
		"0000"; -- disable
end truth_table;

